﻿using System;
using System.Linq;
using Telerik.WinControls.Data;
using Telerik.WinControls.UI;

namespace RadGridViewCustomFilterCellElementExample
{
    public class MyGridFilterCellElement : GridFilterCellElement
    {
        private RadCheckBoxElement check;

        public MyGridFilterCellElement(GridViewDataColumn column, GridRowElement row)
            : base(column, row)
        {
            this.Children.Remove(this.FilterButton);
            this.Children.Remove(this.FilterOperatorText);
        }

        protected override void CreateChildElements()
        {
            base.CreateChildElements();

            StackLayoutElement stack = new StackLayoutElement();
            stack.Orientation = System.Windows.Forms.Orientation.Horizontal;
            stack.StretchVertically = true;
            stack.StretchHorizontally = true;

            RadButtonElement button = new RadButtonElement();
            button.Text = "Sum";
            stack.Children.Add(button);
            check = new RadCheckBoxElement();
            check.Text = "Check";
            stack.Children.Add(check);

            this.Children.Add(stack);

            check.ToggleStateChanged += new StateChangedEventHandler(check_ToggleStateChanged);
        }

        private void check_ToggleStateChanged(object sender, StateChangedEventArgs args)
        {
            if (args.ToggleState == Telerik.WinControls.Enumerations.ToggleState.On)
            {
                this.SetFilterDescriptor(new FilterDescriptor(this.DataColumnInfo.Name, FilterOperator.Contains, 1));
            }
            else
            {
                this.RemoveFilterDescriptor();
            }
        }

        public override void AddEditor(IInputEditor editor)
        { }

        public override void RemoveEditor(IInputEditor editor)
        { }

        public override bool IsCompatible(GridViewColumn data, object context)
        {
            return data is GridViewDataColumn && context is GridFilterRowElement && data.Name.ToUpper() == "COLUMN 1";
        }

        public override void SetContent()
        {
            if (this.DataColumnInfo.FilterDescriptor != null)
            {
                this.check.IsChecked = true;
            }

            base.SetContent();
        }
    }
}
